diff --git a/src/haproxy.c b/src/haproxy.c
index 40758e5de5..bea6db6488 100644
--- a/src/haproxy.c
+++ b/src/haproxy.c
@@ -712,6 +712,8 @@ void mworker_reload()
 	execvp(next_argv[0], next_argv);
 
 	ha_warning("Failed to reexecute the master process [%d]: %s\n", pid, strerror(errno));
+	free(next_argv);
+	next_argv = NULL;
 	return;
 
 alloc_error:
